Index: branches/HeuristicLab.Mono/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Analysis.Views/3.3/HeuristicLab.Analysis.Views-3.3.csproj	(revision 8374)
@@ -104,6 +104,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -202,4 +201,7 @@
       <Private>False</Private>
     </ProjectReference>
+    <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Administrator/3.3/HeuristicLab.Clients.Hive.Administrator-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Administrator/3.3/HeuristicLab.Clients.Hive.Administrator-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Administrator/3.3/HeuristicLab.Clients.Hive.Administrator-3.3.csproj	(revision 8374)
@@ -91,6 +91,5 @@
     <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.ServiceModel" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml" />
     <Reference Include="System.Xml.Linq" />
@@ -142,4 +141,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Clients.Access.Views\3.3\HeuristicLab.Clients.Access.Views-3.3.csproj">
       <Project>{FE856595-64CD-46DA-9CD2-FFF3E6B0D4F2}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.JobManager/3.3/HeuristicLab.Clients.Hive.JobManager-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.JobManager/3.3/HeuristicLab.Clients.Hive.JobManager-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.JobManager/3.3/HeuristicLab.Clients.Hive.JobManager-3.3.csproj	(revision 8374)
@@ -90,6 +90,5 @@
     <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.ServiceModel" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml" />
     <Reference Include="System.Xml.Linq" />
@@ -149,4 +148,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Clients.Hive.Views\3.3\HeuristicLab.Clients.Hive.Views-3.3.csproj">
       <Project>{E1D6C801-892A-406A-B606-F158E36DD3C3}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Slave.Views/3.3/HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Slave.Views/3.3/HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Slave.Views/3.3/HeuristicLab.Clients.Hive.Slave.Views-3.3.csproj	(revision 8374)
@@ -140,6 +140,5 @@
     <Reference Include="System.ServiceModel" />
     <Reference Include="System.ServiceProcess" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -279,4 +278,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Clients.Hive.Slave\3.3\HeuristicLab.Clients.Hive.Slave-3.3.csproj">
       <Project>{989FE92B-484E-41EE-87E2-6A24AF0381D8}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj	(revision 8374)
@@ -87,6 +87,5 @@
     <Reference Include="System.Drawing" />
     <Reference Include="System.Runtime.Serialization" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -177,4 +176,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Clients.Hive\3.3\HeuristicLab.Clients.Hive-3.3.csproj">
       <Project>{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Data/3.3/ValueTypeArray.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 8374)
@@ -43,5 +43,5 @@
     public virtual int Length {
       get { return array.Length; }
-      protected set {
+      set {
         if (ReadOnly) throw new NotSupportedException("Length cannot be set. ValueTypeArray is read-only.");
         if (value != Length) {
Index: branches/HeuristicLab.Mono/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/HeuristicLab.Encodings.PermutationEncoding.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/HeuristicLab.Encodings.PermutationEncoding.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Encodings.PermutationEncoding.Views/3.3/HeuristicLab.Encodings.PermutationEncoding.Views-3.3.csproj	(revision 8374)
@@ -99,5 +99,4 @@
     <Reference Include="System.Drawing" />
     <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -131,4 +130,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj	(revision 8374)
@@ -98,6 +98,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -164,4 +163,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Operators.Views/3.3/HeuristicLab.Operators.Views-3.3.csproj	(revision 8374)
@@ -104,6 +104,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -161,4 +160,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Optimization.Views/3.3/HeuristicLab.Optimization.Views-3.3.csproj	(revision 8374)
@@ -105,6 +105,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -308,4 +307,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Analysis.Views\3.3\HeuristicLab.Analysis.Views-3.3.csproj">
       <Project>{76945D76-CA61-4147-9DC2-0ACDCDDF87F9}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views-3.4.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification.Views-3.4.csproj	(revision 8374)
@@ -98,6 +98,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -129,4 +128,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views-3.4.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression.Views-3.4.csproj	(revision 8374)
@@ -98,6 +98,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -147,4 +146,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Algorithms.DataAnalysis\3.4\HeuristicLab.Algorithms.DataAnalysis-3.4.csproj">
       <Project>{2E782078-FA81-4B70-B56F-74CE38DAC6C8}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 8374)
@@ -102,6 +102,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -181,4 +180,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 8374)
@@ -98,6 +98,5 @@
     </Reference>
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq">
       <RequiredTargetFramework>3.5</RequiredTargetFramework>
@@ -263,4 +262,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
       <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/HeuristicLab.Problems.QuadraticAssignment.Views-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/HeuristicLab.Problems.QuadraticAssignment.Views-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/HeuristicLab.Problems.QuadraticAssignment.Views-3.3.csproj	(revision 8374)
@@ -108,6 +108,5 @@
     <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.ServiceModel" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
   </ItemGroup>
   <ItemGroup>
@@ -139,4 +138,7 @@
   </ItemGroup>
   <ItemGroup>
+   <Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
     <ProjectReference Include="..\..\HeuristicLab.Analysis\3.3\HeuristicLab.Analysis-3.3.csproj">
       <Project>{887425B4-4348-49ED-A457-B7D2C26DDBF9}</Project>
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/RealVectorAdditiveMoveWrapper.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/RealVectorAdditiveMoveWrapper.cs	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.TestFunctions/3.3/MoveEvaluators/RealVectorAdditiveMoveWrapper.cs	(revision 8374)
@@ -66,5 +66,5 @@
         return vector.Length;
       }
-      protected set {
+      set {
         throw new System.NotSupportedException("Error: Setting the lenght of the wrapper is not allowed.");
       }
Index: branches/HeuristicLab.Mono/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj	(revision 8373)
+++ branches/HeuristicLab.Mono/HeuristicLab.Visualization.ChartControlsExtensions/3.3/HeuristicLab.Visualization.ChartControlsExtensions-3.3.csproj	(revision 8374)
@@ -107,6 +107,5 @@
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Windows.Forms" />
-    <Reference Include="System.Windows.Forms.DataVisualization" />
+    <Reference Include="System.Windows.Forms" />    
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -153,4 +152,7 @@
       <Private>False</Private>
     </ProjectReference>
+	<Reference Include="System.Windows.Forms.DataVisualization">
+      <HintPath>..\..\bin\System.Windows.Forms.DataVisualization.dll</HintPath>
+    </Reference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />