Index: branches/OaaS/HeuristicLab.Services.Optimization/HeuristicLab.Services.Optimization.ccproj
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization/HeuristicLab.Services.Optimization.ccproj	(revision 8235)
+++ branches/OaaS/HeuristicLab.Services.Optimization/HeuristicLab.Services.Optimization.ccproj	(revision 8384)
@@ -46,4 +46,12 @@
       <UpdateDiagnosticsConnectionStringOnPublish>True</UpdateDiagnosticsConnectionStringOnPublish>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Services.Optimization.Web\HeuristicLab.Services.Optimization.Web.csproj">
+      <Name>HeuristicLab.Services.Optimization.Web</Name>
+      <Project>{6c07848b-b75f-4a0f-9292-066a636e9a5f}</Project>
+      <Private>True</Private>
+      <RoleType>Web</RoleType>
+      <RoleName>HeuristicLab.Services.Optimization.Web</RoleName>
+      <UpdateDiagnosticsConnectionStringOnPublish>True</UpdateDiagnosticsConnectionStringOnPublish>
+    </ProjectReference>
   </ItemGroup>
   <!-- Import the target files for this project template -->
Index: branches/OaaS/HeuristicLab.Services.Optimization/ServiceConfiguration.Cloud.cscfg
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization/ServiceConfiguration.Cloud.cscfg	(revision 8235)
+++ branches/OaaS/HeuristicLab.Services.Optimization/ServiceConfiguration.Cloud.cscfg	(revision 8384)
@@ -16,3 +16,16 @@
     </Certificates>
   </Role>
+  <Role name="HeuristicLab.Services.Optimization.Web">
+    <Instances count="1" />
+    <ConfigurationSettings>
+      <Setting name="Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString" value="UseDevelopmentStorage=true" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.Enabled" value="true" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountUsername" value="hive" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountEncryptedPassword" value="MIIBnQYJKoZIhvcNAQcDoIIBjjCCAYoCAQAxggFOMIIBSgIBADAyMB4xHDAaBgNVBAMME1dpbmRvd3MgQXp1cmUgVG9vbHMCEBiSEYQzfxGpQrRVsLegHyUwDQYJKoZIhvcNAQEBBQAEggEALEyQxFoVGXNmWbDtfIra3tjA33W3n9ESgfWKGKv3f0Zsggkm3OzznfY9A8HIoZ7WMOvjl8l8gjQTSxSKGJG8052JM1V7y16jM/bjtShmk7N9h2vdX0rjxXLpdXjGji59PeL6rKiGu2ewPbJhNhvdTStqnpHydnvlb79J2ZbK8E5f+7ngCD7Gy9RQc8zm+1y3UzoqXxZlSVKhsVIvZMoIOuJM4TO7klDZJEsG3Rx/CUXFPAPf15H46t1B0zy2FrMW32BeWFr40qbUW+tKjg8Uiiw4EhHDtqryhzE3ZkjoR0iz7KUQBPDtvq8rSz049EW6ejgGuI2jDyW3iLfIeqfZEzAzBgkqhkiG9w0BBwEwFAYIKoZIhvcNAwcECFNbToWlDaTpgBAOc6871l7N2o4Mut92Cooo" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountExpiration" value="2013-07-05T23:59:59.0000000+02:00" />
+    </ConfigurationSettings>
+    <Certificates>
+      <Certificate name="Microsoft.WindowsAzure.Plugins.RemoteAccess.PasswordEncryption" thumbprint="5D180FD78AB82CA765690BBADC60014C6D4A88CA" thumbprintAlgorithm="sha1" />
+    </Certificates>
+  </Role>
 </ServiceConfiguration>
Index: branches/OaaS/HeuristicLab.Services.Optimization/ServiceConfiguration.Local.cscfg
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization/ServiceConfiguration.Local.cscfg	(revision 8235)
+++ branches/OaaS/HeuristicLab.Services.Optimization/ServiceConfiguration.Local.cscfg	(revision 8384)
@@ -16,3 +16,16 @@
     </Certificates>
   </Role>
+  <Role name="HeuristicLab.Services.Optimization.Web">
+    <Instances count="1" />
+    <ConfigurationSettings>
+      <Setting name="Microsoft.WindowsAzure.Plugins.Diagnostics.ConnectionString" value="UseDevelopmentStorage=true" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.Enabled" value="true" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountUsername" value="hive" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountEncryptedPassword" value="MIIBnQYJKoZIhvcNAQcDoIIBjjCCAYoCAQAxggFOMIIBSgIBADAyMB4xHDAaBgNVBAMME1dpbmRvd3MgQXp1cmUgVG9vbHMCEBiSEYQzfxGpQrRVsLegHyUwDQYJKoZIhvcNAQEBBQAEggEALEyQxFoVGXNmWbDtfIra3tjA33W3n9ESgfWKGKv3f0Zsggkm3OzznfY9A8HIoZ7WMOvjl8l8gjQTSxSKGJG8052JM1V7y16jM/bjtShmk7N9h2vdX0rjxXLpdXjGji59PeL6rKiGu2ewPbJhNhvdTStqnpHydnvlb79J2ZbK8E5f+7ngCD7Gy9RQc8zm+1y3UzoqXxZlSVKhsVIvZMoIOuJM4TO7klDZJEsG3Rx/CUXFPAPf15H46t1B0zy2FrMW32BeWFr40qbUW+tKjg8Uiiw4EhHDtqryhzE3ZkjoR0iz7KUQBPDtvq8rSz049EW6ejgGuI2jDyW3iLfIeqfZEzAzBgkqhkiG9w0BBwEwFAYIKoZIhvcNAwcECFNbToWlDaTpgBAOc6871l7N2o4Mut92Cooo" />
+      <Setting name="Microsoft.WindowsAzure.Plugins.RemoteAccess.AccountExpiration" value="2013-07-05T23:59:59.0000000+02:00" />
+    </ConfigurationSettings>
+    <Certificates>
+      <Certificate name="Microsoft.WindowsAzure.Plugins.RemoteAccess.PasswordEncryption" thumbprint="5D180FD78AB82CA765690BBADC60014C6D4A88CA" thumbprintAlgorithm="sha1" />
+    </Certificates>
+  </Role>
 </ServiceConfiguration>
Index: branches/OaaS/HeuristicLab.Services.Optimization/ServiceDefinition.build.csdef
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization/ServiceDefinition.build.csdef	(revision 8235)
+++ branches/OaaS/HeuristicLab.Services.Optimization/ServiceDefinition.build.csdef	(revision 8384)
@@ -33,3 +33,19 @@
     </Certificates>
   </WebRole>
+  <WebRole name="HeuristicLab.Services.Optimization.Web" vmsize="Small">
+    <Sites>
+      <Site name="Web">
+        <Bindings>
+          <Binding name="Endpoint1" endpointName="Endpoint1" />
+        </Bindings>
+      </Site>
+    </Sites>
+    <Endpoints>
+      <InputEndpoint name="Endpoint1" protocol="http" port="8080" />
+    </Endpoints>
+    <Imports>
+      <Import moduleName="Diagnostics" />
+      <Import moduleName="RemoteAccess" />
+    </Imports>
+  </WebRole>
 </ServiceDefinition>
Index: branches/OaaS/HeuristicLab.Services.Optimization/ServiceDefinition.csdef
===================================================================
--- branches/OaaS/HeuristicLab.Services.Optimization/ServiceDefinition.csdef	(revision 8235)
+++ branches/OaaS/HeuristicLab.Services.Optimization/ServiceDefinition.csdef	(revision 8384)
@@ -24,3 +24,19 @@
     </Certificates>
   </WebRole>
+  <WebRole name="HeuristicLab.Services.Optimization.Web" vmsize="Small">
+    <Sites>
+      <Site name="Web">
+        <Bindings>
+          <Binding name="Endpoint1" endpointName="Endpoint1" />
+        </Bindings>
+      </Site>
+    </Sites>
+    <Endpoints>
+      <InputEndpoint name="Endpoint1" protocol="http" port="8080" />
+    </Endpoints>
+    <Imports>
+      <Import moduleName="Diagnostics" />
+      <Import moduleName="RemoteAccess" />
+    </Imports>
+  </WebRole>
 </ServiceDefinition>