Index: /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj	(revision 8394)
+++ /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views-3.4.csproj	(revision 8395)
@@ -257,12 +257,4 @@
     </ProjectReference>
   </ItemGroup>
-  <ItemGroup>
-    <EmbeddedResource Include="InteractiveSymbolicExpressionTreeChart.resx">
-      <DependentUpon>InteractiveSymbolicExpressionTreeChart.cs</DependentUpon>
-    </EmbeddedResource>
-    <EmbeddedResource Include="SymbolicExpressionTreeNodeInsertDialog.resx">
-      <DependentUpon>SymbolicExpressionTreeNodeInsertDialog.cs</DependentUpon>
-    </EmbeddedResource>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: anches/HeuristicLab.TreeSimplifier/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/PreBuildEvent.cmd	(revision 8394)
+++ 	(revision )
@@ -1,1 +1,0 @@
-SubWCRev "%ProjectDir%\." "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
Index: anches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic.Classification/3.4/PreBuildEvent.cmd	(revision 8394)
+++ 	(revision )
@@ -1,1 +1,0 @@
-SubWCRev "%ProjectDir%\." "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
Index: anches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic.Regression/3.4/PreBuildEvent.cmd	(revision 8394)
+++ 	(revision )
@@ -1,1 +1,0 @@
-SubWCRev "%ProjectDir%\." "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
Index: anches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/PreBuildEvent.cmd	(revision 8394)
+++ 	(revision )
@@ -1,1 +1,0 @@
-SubWCRev "%ProjectDir%\." "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
Index: anches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/PreBuildEvent.cmd	(revision 8394)
+++ 	(revision )
@@ -1,1 +1,0 @@
-SubWCRev "%ProjectDir%\." "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"
Index: /branches/HeuristicLab.TreeSimplifier/HeuristicLab.TreeSimplifier.sln
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/HeuristicLab.TreeSimplifier.sln	(revision 8394)
+++ /branches/HeuristicLab.TreeSimplifier/HeuristicLab.TreeSimplifier.sln	(revision 8395)
@@ -11,4 +11,9 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4", "HeuristicLab.Problems.DataAnalysis.Symbolic.Views\3.4\HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj", "{7A2531CE-3F7C-4F13-BCCA-ED6DC27A7086}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{F628EAED-43DC-4D00-A4D4-4757D696D873}"
+	ProjectSection(SolutionItems) = preProject
+		PreBuildEvent.cmd = PreBuildEvent.cmd
+	EndProjectSection
 EndProject
 Global
Index: /branches/HeuristicLab.TreeSimplifier/PreBuildEvent.cmd
===================================================================
--- /branches/HeuristicLab.TreeSimplifier/PreBuildEvent.cmd	(revision 8395)
+++ /branches/HeuristicLab.TreeSimplifier/PreBuildEvent.cmd	(revision 8395)
@@ -0,0 +1,1 @@
+SubWCRev "%ProjectDir%\." "%ProjectDir%\Properties\AssemblyInfo.cs.frame" "%ProjectDir%\Properties\AssemblyInfo.cs"