Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/ExpressionEvaluator.cs
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/ExpressionEvaluator.cs	(revision 8402)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/ExpressionEvaluator.cs	(revision 8406)
@@ -1,4 +1,3 @@
 ﻿#region License Information
-
 /* HeuristicLab
  * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -19,5 +18,4 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/HeuristicLab.Algorithms.RAPGA-3.3.csproj
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/HeuristicLab.Algorithms.RAPGA-3.3.csproj	(revision 8402)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/HeuristicLab.Algorithms.RAPGA-3.3.csproj	(revision 8406)
@@ -104,4 +104,6 @@
     <Compile Include="OffspringRestorer.cs" />
     <Compile Include="ProgressiveOffspringPreserver.cs" />
+    <Compile Include="SimilarityCalculator\BlindSimilarityCalculator.cs" />
+    <Compile Include="SimilarityCalculator\QualitySimilarityCalculator.cs" />
     <Compile Include="RAPGA.cs" />
     <Compile Include="RAPGAMainLoop.cs" />
Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/OffspringRestorer.cs
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/OffspringRestorer.cs	(revision 8402)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/OffspringRestorer.cs	(revision 8406)
@@ -1,4 +1,3 @@
 ﻿#region License Information
-
 /* HeuristicLab
  * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -19,5 +18,4 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/ProgressiveOffspringPreserver.cs
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/ProgressiveOffspringPreserver.cs	(revision 8402)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/ProgressiveOffspringPreserver.cs	(revision 8406)
@@ -1,4 +1,3 @@
 ﻿#region License Information
-
 /* HeuristicLab
  * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -19,5 +18,4 @@
  * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
  */
-
 #endregion
 
Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 8402)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/RAPGA.cs	(revision 8406)
@@ -322,9 +322,12 @@
       base.Problem_OperatorsChanged(sender, e);
     }
-    void BatchSizeParameter_ValueChanged(object sender, EventArgs e) {
+    private void SimilarityCalculatorParameter_ValueChanged(object sender, EventArgs e) {
+      ParameterizeRAPGAMainLoop();
+    }
+    private void BatchSizeParameter_ValueChanged(object sender, EventArgs e) {
       BatchSize.ValueChanged += new EventHandler(BatchSize_ValueChanged);
       ParameterizeSelectors();
     }
-    void BatchSize_ValueChanged(object sender, EventArgs e) {
+    private void BatchSize_ValueChanged(object sender, EventArgs e) {
       ParameterizeSelectors();
     }
@@ -359,4 +362,5 @@
       BatchSizeParameter.ValueChanged += new EventHandler(BatchSizeParameter_ValueChanged);
       BatchSize.ValueChanged += new EventHandler(BatchSize_ValueChanged);
+      SimilarityCalculatorParameter.ValueChanged += new EventHandler(SimilarityCalculatorParameter_ValueChanged);
       if (Problem != null) {
         Problem.Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
@@ -472,4 +476,7 @@
       ISolutionSimilarityCalculator defaultSimilarityCalculator = Problem.Operators.OfType<ISolutionSimilarityCalculator>().FirstOrDefault();
 
+      SimilarityCalculatorParameter.ValidValues.Add(new BlindSimilarityCalculator());
+      SimilarityCalculatorParameter.ValidValues.Add(new QualitySimilarityCalculator());
+
       foreach (ISolutionSimilarityCalculator similarityCalculator in Problem.Operators.OfType<ISolutionSimilarityCalculator>())
         SimilarityCalculatorParameter.ValidValues.Add(similarityCalculator);
Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/SimilarityCalculator/BlindSimilarityCalculator.cs
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/SimilarityCalculator/BlindSimilarityCalculator.cs	(revision 8406)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/SimilarityCalculator/BlindSimilarityCalculator.cs	(revision 8406)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization.Operators;
+
+namespace HeuristicLab.Algorithms.RAPGA {
+  /// <summary>
+  /// An item that performs similarity calculation between two solutions.
+  /// </summary>
+  /// <remarks>
+  /// The item always considers two solutions to be distinct.
+  /// </remarks>
+  [Item("BlindSimilarityCalculator", "An item that performs similarity calculation between two solutions. The item always considers two solutions to be distinct.")]
+  public sealed class BlindSimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator {
+    private BlindSimilarityCalculator(bool deserializing) : base(deserializing) { }
+    private BlindSimilarityCalculator(BlindSimilarityCalculator original, Cloner cloner) : base(original, cloner) { }
+    public BlindSimilarityCalculator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new BlindSimilarityCalculator(this, cloner);
+    }
+
+    public static double CalculateSimilarity(IScope left, IScope right) {
+      return 0.0;
+    }
+
+    public override double CalculateSolutionSimilarity(IScope leftSolution, IScope rightSolution) {
+      return CalculateSimilarity(leftSolution, rightSolution);
+    }
+  }
+}
Index: branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/SimilarityCalculator/QualitySimilarityCalculator.cs
===================================================================
--- branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/SimilarityCalculator/QualitySimilarityCalculator.cs	(revision 8406)
+++ branches/RAPGA/HeuristicLab.Algorithms.RAPGA/3.3/SimilarityCalculator/QualitySimilarityCalculator.cs	(revision 8406)
@@ -0,0 +1,52 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization.Operators;
+
+namespace HeuristicLab.Algorithms.RAPGA {
+  /// <summary>
+  /// An item that performs similarity calculation between two solutions.
+  /// </summary>
+  /// <remarks>
+  /// The item always considers two solutions to be equal if they have the same quality.
+  /// </remarks>
+  [Item("QualitySimilarityCalculator", "An item that performs similarity calculation between two solutions. The item always considers two solutions to be distinct.")]
+  public sealed class QualitySimilarityCalculator : SingleObjectiveSolutionSimilarityCalculator {
+    private QualitySimilarityCalculator(bool deserializing) : base(deserializing) { }
+    private QualitySimilarityCalculator(QualitySimilarityCalculator original, Cloner cloner) : base(original, cloner) { }
+    public QualitySimilarityCalculator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new QualitySimilarityCalculator(this, cloner);
+    }
+
+    public static double CalculateSimilarity(IScope left, IScope right, string qualityVariableName) {
+      return ((DoubleValue)left.Variables[qualityVariableName].Value).Value == ((DoubleValue)right.Variables[qualityVariableName].Value).Value ? 1.0 : 0.0;
+    }
+
+    public override double CalculateSolutionSimilarity(IScope leftSolution, IScope rightSolution) {
+      return CalculateSimilarity(leftSolution, rightSolution, QualityVariableName);
+    }
+  }
+}